Subject: WGLC p1: Persistence & 1.1 proxies

From: Ben Niven-Jenkins <[email-masked]>
Date: Mon, 29 Apr 2013 20:25:13 +0100

Hi,

Section 6.3 of p1 states:

   o  If the received protocol is HTTP/1.0, the "keep-alive" connection
      option is present, the recipient is not a proxy, and the recipient
      wishes to honor the HTTP/1.0 "keep-alive" mechanism, the
      connection will persist after the current response; otherwise,

and then later on in the same section states:

   A proxy server MUST NOT maintain a persistent connection with an
   HTTP/1.0 client (see Section 19.7.1 of [RFC2068] for information and
   discussion of the problems with the Keep-Alive header field
   implemented by many HTTP/1.0 clients).

It is not clear that the solution proposed actually solves the issue at hand.

AIUI Section 19.7.1 of RFC2068 describes a case where persistent connections can break between HTTP/1.0 clients & servers if there is a HTTP/1.0 proxy in the middle that does not support persistent connections.

The solution in p1 (according to the text quoted above) is for a HTTP/1.1 proxy not to maintain persistent connections with HTTP/1.0 clients but I don't see how that solves the issue referred to by reference to 2068 (HTTP/1.0 proxy that doesn't support persistence between two HTTP/1.0 implementations that do breaks persistence) or why proxies are called out for special attention as the same issue appears to affect HTTP/1.1 servers talking to HTTP/1.0 client, no?

It would appear that either:
- The advice for proxies not to maintain persistent connections with HTTP/1.0 clients is correct but the justification for it (19.7.1 of RFC2068) is wrong/not relevant.
- The problem trying to be solved is that described in 19.7.1 of RFC2068 but the advice for alleviating the issue doesn't in fact alleviate it.

Thanks
Ben